UNIT my_utils;


{*** with credits to DL1BHO, DL5FBD ***}


INTERFACE

USES Crt, Dos, Graph;


FUNCTION ConstStr(CH : Char ; L : Integer) : String;
FUNCTION CutStr (Zeile : String) : String;
FUNCTION Date : String;
FUNCTION Time : String;
FUNCTION LPT1_Error : Boolean;
PROCEDURE Pause_bis_Tastendruck;
PROCEDURE Sirene(anzahl : Byte);
PROCEDURE Triller(anzahl : Byte);
PROCEDURE ton(frequenz, laenge : Word; anzahl : Byte);
FUNCTION Uebergabe ( Zeile : String) : Boolean;
FUNCTION Ganze_Uebergabe : String;
FUNCTION UpcaseStr (Zeile : String) : String;
FUNCTION ZiS(Z:Word; L : Byte):String;
FUNCTION SiZ(Str: String) : LongInt;  { gendert von Word }
FUNCTION Zentrieren(s : String) : String;


IMPLEMENTATION

VAR LPT1_Base  : Integer ABSOLUTE 0:$0408;  (* Basisadresse fr LPT1: *)


(* ConstStr liefert einen String der Lnge L, gefllt mit Zeichen ch *)

FUNCTION ConstStr;
VAR B_Str : String;
BEGIN
  FillChar(B_Str,SizeOf(B_Str),CH);
  IF L > 0 THEN B_Str[0] := Chr(L) ELSE B_Str[0] := #0;
  ConstStr := B_Str;
END;




(* CutStr liefert einen String bis zum ersten Leerzeichen *)

FUNCTION CutStr;
VAR  i  : Integer;
BEGIN
  i := Pos(' ',Zeile);
  IF (i = 0) THEN i := Length(Zeile) ELSE Dec(i);
  CutStr := Copy(Zeile,1,i);
END;



(* gibt Datumstring zurueck, z.B 'Di 19.05.87' *)

FUNCTION Date;

CONST Wochentag = 'SoMoDiMiDoFrSa';

VAR
  Tag,
  WoTag,
  Monat,
  Jahr          : Word;
  TagStr,
  WotagStr,
  MonatStr,
  JahrStr       : String[2];

BEGIN (* Date *)

  GetDate(Jahr, Monat, Tag, WoTag);  (* PROCEDURE im Unit DOS *)
  Str(Tag:2,TagStr);
  Str(Monat:2,MonatStr);
  Str(Jahr-1900,JahrStr);
  Str(WoTag,WotagStr);
  WotagStr := Copy(Wochentag,WoTag*2+1,2);

  IF Tag < 10 THEN TagStr[1] := '0';
  IF Monat < 10 THEN MonatStr[1] := '0';

  Date := WotagStr + ' ' + TagStr + '.' + MonatStr + '.' + JahrStr;

END;


(* Gibt einen ZeitString zurueck, z.B. '18:34:56' *)

FUNCTION Time;

VAR
  Stunden,
  Minuten,
  Sekunden,
  Sek100        : Word;
  StundenStr,
  MinutenStr,
  SekundenStr   : String[2];

BEGIN (* Time *)

  GetTime(Stunden, Minuten, Sekunden, Sek100);   (* PROCEDURE im Unit DOS *)
  Str(Stunden:2,StundenStr);
  Str(Minuten:2,MinutenStr);
  Str(Sekunden:2,SekundenStr);

  IF Stunden < 10 THEN StundenStr[1] := '0';
  IF Minuten < 10 THEN MinutenStr[1] := '0';
  IF Sekunden < 10 THEN SekundenStr[1] := '0';

 Time := StundenStr + ':' + MinutenStr + ':' + SekundenStr;

END;



FUNCTION LPT1_Error;
BEGIN
  LPT1_Error := ((Port[LPT1_Base + 1] AND 184) <> 152);
END;



PROCEDURE Pause_bis_Tastendruck;
VAR  CH  : Char;
BEGIN
  REPEAT UNTIL KeyPressed;
  CH := ReadKey;
  IF (CH = #0) AND KeyPressed THEN CH := ReadKey;
END;


PROCEDURE Sirene; { Alarmsirene ber PC-Lautsprecher }

VAR i, j, k : Word;

BEGIN
  FOR k := 1 TO anzahl DO BEGIN
     FOR i := 10 TO 200 DO BEGIN
        Sound(i*15);
        Delay(1);
     END;
     NoSound;
  END;
END;



PROCEDURE Triller;
VAR   i     : Integer;
BEGIN
  FOR i := 1 TO anzahl DO
  BEGIN
    Sound(880);
    Delay(60);
    Sound(1200);
    Delay(60);
  END;
  NoSound;
  Delay(300);
END;


PROCEDURE ton;
VAR i : Byte;
BEGIN
   FOR i := 1 TO anzahl DO BEGIN
      Sound(frequenz);
      Delay(laenge);
      NoSound;
      IF anzahl <> 1 THEN Delay(laenge);
   END;
END;



(* Feststellen, ob der String ZEILE beim Prog.Aufruf uebergeben wurde *)

FUNCTION Uebergabe;
VAR merker    : Boolean;
    i,k       : Integer;
    B_Str     : String[30];
BEGIN
  merker := FALSE;
  FOR i := 1 TO ParamCount DO
  BEGIN
    B_Str := ParamStr(i);
    FOR k := 1 TO Length(B_Str) DO B_Str[k] := UpCase(B_Str[k]);
    IF B_Str = Zeile THEN merker := TRUE;
  END;
  Uebergabe := merker;
END;




FUNCTION Ganze_Uebergabe;
VAR merker    : Boolean;
    i,k       : Integer;
    B_Str     : String;
BEGIN
  B_Str := '';
  FOR i := 1 TO ParamCount DO
  BEGIN
    B_Str := B_Str + ParamStr(i) + ' ';
  END;
  Ganze_Uebergabe := B_Str;
END;


FUNCTION UpcaseStr (* (Zeile : STRING) : STRING *) ;
TYPE Z = SET OF '0'..'9';
VAR  i   : Integer;
     Ziffer : Z;
BEGIN
  FOR i := 1 TO Length(Zeile) DO BEGIN
    IF NOT (Zeile[i] IN Ziffer) THEN Zeile[i] := UpCase(Zeile[i]);
    CASE Zeile[i] OF
       '' : Zeile[i] := '';
       '' : Zeile[i] := '';
       '' : Zeile[i] := '';
    END;
  END;
  UpcaseStr := Zeile;
END;

{-------------------------------------------------------------------------}
{Function ZIS                                                             }
{Diese Function wandelt eine Zahl vom Typ Integer,Byte,WORD in eine String}
{Diese Function ist anwendungsfreundlicher als die Standard-Procedure STR }
{Interne Variablen:                                                       }
{Dummi         :Hilfsstring fuer STR-Procedure                            }
{-------------------------------------------------------------------------}

FUNCTION ZiS;

VAR Dummi    :String[5];
    i : Byte;

BEGIN
  Str(Z,Dummi);  {Integer,Byte,WORD->String als Function}
  IF (Length(Dummi) < L) AND (L <> 0) THEN BEGIN  { l = 0 --> kein Auffllen }
     FOR i := Length(Dummi) TO L-1 DO Dummi := '0' + Dummi;
  END;
  ZiS:=Dummi;
END;

FUNCTION SiZ(Str: String) : LongInt;   { von Word }
VAR Code : Integer;
    Z : Word;

BEGIN
   Val(Str,Z,Code);
   SiZ := Z;
END;


FUNCTION Zentrieren;

VAR i, tab : Byte;

BEGIN
  tab:=(80-Length(s))DIV 2;
  FOR i:=1 TO tab DO s :=' '+s+' ';
  IF Length(s)<80 THEN s:=s+' ';
  Zentrieren := s;
END;


{ --------------------------------------------------------------------- }

END.
